/*******************************************************************************
* File Name: Filter.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_Filter_H) /* Pins Filter_H */
#define CY_PINS_Filter_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Filter_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Filter_Write(uint8 value) ;
void    Filter_SetDriveMode(uint8 mode) ;
uint8   Filter_ReadDataReg(void) ;
uint8   Filter_Read(void) ;
uint8   Filter_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Filter_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Filter_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Filter_DM_RES_UP          PIN_DM_RES_UP
#define Filter_DM_RES_DWN         PIN_DM_RES_DWN
#define Filter_DM_OD_LO           PIN_DM_OD_LO
#define Filter_DM_OD_HI           PIN_DM_OD_HI
#define Filter_DM_STRONG          PIN_DM_STRONG
#define Filter_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Filter_MASK               Filter__MASK
#define Filter_SHIFT              Filter__SHIFT
#define Filter_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Filter_PS                     (* (reg8 *) Filter__PS)
/* Data Register */
#define Filter_DR                     (* (reg8 *) Filter__DR)
/* Port Number */
#define Filter_PRT_NUM                (* (reg8 *) Filter__PRT) 
/* Connect to Analog Globals */                                                  
#define Filter_AG                     (* (reg8 *) Filter__AG)                       
/* Analog MUX bux enable */
#define Filter_AMUX                   (* (reg8 *) Filter__AMUX) 
/* Bidirectional Enable */                                                        
#define Filter_BIE                    (* (reg8 *) Filter__BIE)
/* Bit-mask for Aliased Register Access */
#define Filter_BIT_MASK               (* (reg8 *) Filter__BIT_MASK)
/* Bypass Enable */
#define Filter_BYP                    (* (reg8 *) Filter__BYP)
/* Port wide control signals */                                                   
#define Filter_CTL                    (* (reg8 *) Filter__CTL)
/* Drive Modes */
#define Filter_DM0                    (* (reg8 *) Filter__DM0) 
#define Filter_DM1                    (* (reg8 *) Filter__DM1)
#define Filter_DM2                    (* (reg8 *) Filter__DM2) 
/* Input Buffer Disable Override */
#define Filter_INP_DIS                (* (reg8 *) Filter__INP_DIS)
/* LCD Common or Segment Drive */
#define Filter_LCD_COM_SEG            (* (reg8 *) Filter__LCD_COM_SEG)
/* Enable Segment LCD */
#define Filter_LCD_EN                 (* (reg8 *) Filter__LCD_EN)
/* Slew Rate Control */
#define Filter_SLW                    (* (reg8 *) Filter__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Filter_PRTDSI__CAPS_SEL       (* (reg8 *) Filter__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Filter_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Filter__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Filter_PRTDSI__OE_SEL0        (* (reg8 *) Filter__PRTDSI__OE_SEL0) 
#define Filter_PRTDSI__OE_SEL1        (* (reg8 *) Filter__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Filter_PRTDSI__OUT_SEL0       (* (reg8 *) Filter__PRTDSI__OUT_SEL0) 
#define Filter_PRTDSI__OUT_SEL1       (* (reg8 *) Filter__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Filter_PRTDSI__SYNC_OUT       (* (reg8 *) Filter__PRTDSI__SYNC_OUT) 


#if defined(Filter__INTSTAT)  /* Interrupt Registers */

    #define Filter_INTSTAT                (* (reg8 *) Filter__INTSTAT)
    #define Filter_SNAP                   (* (reg8 *) Filter__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins Filter_H */


/* [] END OF FILE */
