/*******************************************************************************
* FILENAME: cyfitter_cfg.c
* PSoC Creator 1.0 Service Pack 2
*
* Description:
* This file contains device initialization code. This file is automatically
* generated by PSoC Creator.
*
********************************************************************************
* Copyright 2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include <string.h>
#include <cytypes.h>
#include <cydevice_trm.h>
#include <cyfitter.h>
#include <CyLib.h>
#include <cyfitter_cfg.h>

/* Clock startup error codes                                                   */
#define CYCLOCKSTART_NO_ERROR    0
#define CYCLOCKSTART_XTAL_ERROR  1
#define CYCLOCKSTART_32KHZ_ERROR 2
#define CYCLOCKSTART_PLL_ERROR   3

/*******************************************************************************
* Function Name: CyClockStartupError
********************************************************************************
* Summary:
*  If an error is encountered during clock configuration (crystal startup error,
*  PLL lock error, etc) the system will end up here.  Unless reimplemented by 
*  the customer, an infinite loop will be encountered.
*
* Parameters:  
*   void.
*
*
* Return:
*   void.
*
*******************************************************************************/
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void CyClockStartupError(uint8 errorCode)
{
    /* To remove the compiler warning if errorCode not used.                */
    errorCode = errorCode;

    /* `#START CyClockStartupError` */

    /* `#END` */

    /* If nothing else, stop here since the clocks have not started         */
    /* correctly.                                                           */
    while(1) {}
}

/* This file contains the data used to initialize the device. */

#undef CYCODE
#undef CYDATA
#undef CYXDATA
#undef CYFAR
#if defined(__C51__) || defined(__CX51__)
#define CYCODE code
#define CYDATA data
#define CYXDATA xdata
#define CYFAR far
extern void cymemzero(void CYFAR *addr, uint16 size);
extern void cyconfigcpy(uint16 size, const void CYFAR *src, void CYFAR *dest) small;
extern void cyconfigcpycode(uint16 size, const void CYCODE *src, void CYFAR *dest);
#define CYMEMZERO(a,c) cymemzero((a),(c))
#define CYCONFIGCPY(d,s,c) cyconfigcpy((c),(s),(d))
#define CYCONFIGCPYCODE(d,s,c) cyconfigcpycode((c),(s),(d))
#else
#define CYCODE
#define CYDATA
#define CYXDATA
#define CYFAR
#define CYMEMZERO(a,c) cymemset((a),0,(c))
#define CYCONFIGCPY(d,s,c) cymemcpy((d),(s),(c))
#define CYCONFIGCPYCODE(d,s,c) cymemcpy((d),(s),(c))
#endif

#if defined(__GNUC__) || defined(__ARMCC_VERSION)
#define CYPACKED __attribute__ ((packed))
#define CYALIGNED __attribute__ ((aligned))
#if CYDEV_CONFIGURATION_DMA
#define DMAINITSEC __attribute__ ((section (".dma_init")))
#else
#define DMAINITSEC
#endif
#if defined(__ARMCC_VERSION)
#define CY_CFG_MEMORY_BARRIER() __memory_changed()
#else
#define CY_CFG_MEMORY_BARRIER() __sync_synchronize()
#endif
#else
/* Keil C51 and others */
#define CYPACKED
#define CYALIGNED
#define DMAINITSEC
#define CY_CFG_MEMORY_BARRIER()
#endif

typedef struct {
	void CYFAR *address;
	uint16 size;
} CYPACKED cfg_memset_t;

typedef struct {
	void CYFAR *dest;
	const void CYCODE *src;
	uint16 size;
} CYPACKED cfg_memcpy_t;


#if defined(__C51__) || defined(__CX51__)
#define CYMEMZERO8(a,c) cymemzero((a),(c))
#define CYCONFIGCPY8(d,s,c) cyconfigcpy((c),(s),(d))
#define CYCONFIGCPYCODE8(d,s,c) cyconfigcpycode((c),(s),(d))
#else
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void cymemzero8(void *addr, unsigned int count)
{
	volatile uint8 *addr8 = (uint8 *)addr;
	while (count--)
	{
		*addr8 = 0;
		addr8++;
	}
}

#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void cymemcpy8(void *dest, const void *src, unsigned int count)
{
	volatile uint8 *dest8 = (uint8 *)dest;
	const uint8 *src8 = (const uint8 *)src;

	while (count--)
	{
		*dest8 = *src8;
		dest8++;
		src8++;
	}
}

#define CYMEMZERO8(a,c) cymemzero8((a),(c))
#define CYCONFIGCPY8(d,s,c) cymemcpy8((d),(s),(c))
#define CYCONFIGCPYCODE8(d,s,c) cymemcpy8((d),(s),(c))
#endif

#define CFG_MEMSET_COUNT (sizeof(cfg_memset_list)/sizeof(*cfg_memset_list))
static const cfg_memset_t CYCODE cfg_memset_list [] = {
	/* address, size */
	{(void CYFAR *)(CYREG_PRT1_DR), 16},
	{(void CYFAR *)(CYREG_PRT3_DR), 48},
	{(void CYFAR *)(CYREG_PRT12_DR), 16},
	{(void CYFAR *)(CYDEV_UCFG_B0_P0_U0_BASE), 4096},
	{(void CYFAR *)(CYDEV_UCFG_B1_P2_U0_BASE), 2048},
	{(void CYFAR *)(CYDEV_UCFG_DSI0_BASE), 2560},
	{(void CYFAR *)(CYDEV_UCFG_DSI12_BASE), 512},
};

#define CY_CFG_BASE_ADDR_COUNT 24
typedef struct
{
	uint8 offset;
	uint8 value;
} CYPACKED cy_cfg_addrvalue_t;

static const uint32 CYCODE cy_cfg_addr_table[] = {
	0x40005A01u, /* Base address: 0x40005A00 Count: 1 */
	0x40010207u, /* Base address: 0x40010200 Count: 7 */
	0x40010305u, /* Base address: 0x40010300 Count: 5 */
	0x40010505u, /* Base address: 0x40010500 Count: 5 */
	0x40010603u, /* Base address: 0x40010600 Count: 3 */
	0x40010706u, /* Base address: 0x40010700 Count: 6 */
	0x40010901u, /* Base address: 0x40010900 Count: 1 */
	0x40010B01u, /* Base address: 0x40010B00 Count: 1 */
	0x40010D01u, /* Base address: 0x40010D00 Count: 1 */
	0x40011701u, /* Base address: 0x40011700 Count: 1 */
	0x40011901u, /* Base address: 0x40011900 Count: 1 */
	0x40014006u, /* Base address: 0x40014000 Count: 6 */
	0x4001410Eu, /* Base address: 0x40014100 Count: 14 */
	0x40014208u, /* Base address: 0x40014200 Count: 8 */
	0x40014305u, /* Base address: 0x40014300 Count: 5 */
	0x40014406u, /* Base address: 0x40014400 Count: 6 */
	0x40014504u, /* Base address: 0x40014500 Count: 4 */
	0x40014603u, /* Base address: 0x40014600 Count: 3 */
	0x40014704u, /* Base address: 0x40014700 Count: 4 */
	0x4001480Eu, /* Base address: 0x40014800 Count: 14 */
	0x40014912u, /* Base address: 0x40014900 Count: 18 */
	0x40014C02u, /* Base address: 0x40014C00 Count: 2 */
	0x40015003u, /* Base address: 0x40015000 Count: 3 */
	0x40015101u, /* Base address: 0x40015100 Count: 1 */
};

static const cy_cfg_addrvalue_t CYCODE cy_cfg_data_table[] = {
	{0x87u, 0x01u},
	{0x20u, 0x02u},
	{0x22u, 0x01u},
	{0x2Au, 0x03u},
	{0x32u, 0x02u},
	{0x36u, 0x01u},
	{0x3Eu, 0x44u},
	{0x58u, 0x04u},
	{0x14u, 0x40u},
	{0x17u, 0x20u},
	{0x1Fu, 0x84u},
	{0xC4u, 0x50u},
	{0xECu, 0x40u},
	{0x9Cu, 0x40u},
	{0xB3u, 0x04u},
	{0xB7u, 0xA0u},
	{0xEAu, 0xC0u},
	{0xECu, 0x30u},
	{0x56u, 0x08u},
	{0x5Bu, 0x04u},
	{0x5Du, 0x90u},
	{0x5Fu, 0x02u},
	{0x64u, 0x40u},
	{0x9Cu, 0x40u},
	{0xD6u, 0x80u},
	{0xD8u, 0x80u},
	{0xECu, 0x80u},
	{0xECu, 0x80u},
	{0xECu, 0x20u},
	{0xECu, 0x40u},
	{0xB7u, 0x02u},
	{0xEAu, 0x10u},
	{0x30u, 0x01u},
	{0x32u, 0x20u},
	{0x35u, 0x20u},
	{0x4Au, 0x20u},
	{0x4Bu, 0x02u},
	{0xCCu, 0x70u},
	{0x13u, 0x04u},
	{0x17u, 0x0Cu},
	{0x3Cu, 0x40u},
	{0x43u, 0x20u},
	{0x97u, 0x02u},
	{0x9Cu, 0x01u},
	{0x9Du, 0x20u},
	{0x9Fu, 0x08u},
	{0xB7u, 0x08u},
	{0xC4u, 0x30u},
	{0xC6u, 0x10u},
	{0xCAu, 0x20u},
	{0xCEu, 0x20u},
	{0xD0u, 0x10u},
	{0x1Fu, 0x40u},
	{0x97u, 0x02u},
	{0x9Cu, 0x01u},
	{0x9Du, 0x20u},
	{0xB3u, 0x24u},
	{0xB4u, 0x40u},
	{0xB7u, 0x04u},
	{0xC6u, 0x80u},
	{0x97u, 0x02u},
	{0x9Cu, 0x01u},
	{0x9Du, 0x20u},
	{0xB3u, 0x40u},
	{0xC2u, 0x10u},
	{0x30u, 0x80u},
	{0x45u, 0x02u},
	{0x76u, 0x40u},
	{0xCCu, 0x08u},
	{0xD0u, 0x01u},
	{0xDEu, 0x04u},
	{0x9Eu, 0x40u},
	{0xA5u, 0x02u},
	{0xB4u, 0x80u},
	{0xECu, 0x02u},
	{0x9Eu, 0x40u},
	{0xB1u, 0x02u},
	{0xECu, 0x04u},
	{0x07u, 0x02u},
	{0xB2u, 0x40u},
	{0xC0u, 0x01u},
	{0xECu, 0x01u},
	{0x23u, 0x10u},
	{0x27u, 0x40u},
	{0x29u, 0x21u},
	{0x2Du, 0x08u},
	{0x2Fu, 0x01u},
	{0x31u, 0x01u},
	{0x33u, 0x40u},
	{0x35u, 0x08u},
	{0x97u, 0x02u},
	{0x9Cu, 0x01u},
	{0x9Du, 0x20u},
	{0xC8u, 0xC0u},
	{0xCAu, 0xF0u},
	{0xCCu, 0xD0u},
	{0x23u, 0x20u},
	{0x24u, 0x40u},
	{0x27u, 0x04u},
	{0x28u, 0x01u},
	{0x2Eu, 0x80u},
	{0x30u, 0x10u},
	{0x33u, 0x04u},
	{0x37u, 0x20u},
	{0x3Bu, 0x10u},
	{0x3Cu, 0x40u},
	{0x44u, 0x10u},
	{0x46u, 0x80u},
	{0x93u, 0x10u},
	{0x9Cu, 0x01u},
	{0xC8u, 0xE0u},
	{0xCAu, 0x30u},
	{0xCCu, 0x70u},
	{0xCEu, 0x30u},
	{0xB7u, 0x02u},
	{0xEAu, 0x08u},
	{0x01u, 0x01u},
	{0x02u, 0x10u},
	{0x0Bu, 0x01u},
	{0x11u, 0x82u},
};


/* IDMUX_IRQ Address: CYREG_IDMUX_IRQ_CTL0 Size (bytes): 8 */
static const uint8 CYCODE BS_IDMUX_IRQ_VAL[] DMAINITSEC = {
	0x2A, 0x00, 0x00, 0x00, 0x00, 0x88, 0xA2, 0xA2};

/* IOPINS0_0 Address: CYREG_PRT0_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_0_VAL[] DMAINITSEC = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA8, 0x00};

/* IOPINS0_8 Address: CYREG_PRT15_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_8_VAL[] DMAINITSEC = {
	0x08, 0x08, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00};

/* IOPINS0_2 Address: CYREG_PRT2_DR Size (bytes): 10 */
static const uint8 CYCODE BS_IOPINS0_2_VAL[] DMAINITSEC = {
	0x80, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

/* IOPINS0_6 Address: CYREG_PRT6_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_6_VAL[] DMAINITSEC = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00};

/* IOPORT_2 Address: CYDEV_PRTDSI_PRT2_BASE Size (bytes): 7 */
static const uint8 CYCODE BS_IOPORT_2_VAL[] DMAINITSEC = {
	0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00};

/* CYDEV_CLKDIST_ACFG0_CFG0 Address: CYREG_CLKDIST_ACFG0_CFG0 Size (bytes): 8 */
static const uint8 CYCODE BS_CYDEV_CLKDIST_ACFG0_CFG0_VAL[] DMAINITSEC = {
	0x92, 0x00, 0x18, 0x01, 0x63, 0x00, 0x1B, 0x01};

#define CFG_MEMCPY_COUNT (sizeof(cfg_memcpy_list)/sizeof(*cfg_memcpy_list))
static const cfg_memcpy_t CYCODE cfg_memcpy_list [] = {
	/* dest, src, size */
	{(void CYFAR *)(CYREG_IDMUX_IRQ_CTL0), BS_IDMUX_IRQ_VAL, 8},
};


#if defined(__C51__) || defined(__CX51__)
extern void cfg_write_bytes_code(void CYCODE *table);
extern void cfg_write_bytes(void CYFAR *table);
#else
/* For 32-bit little-endian architectures */
static void cfg_write_bytes32(void)
{
	unsigned int i, j = 0;
	for (i = 0; i < CY_CFG_BASE_ADDR_COUNT; i++)
	{
		uint32 baseAddr = cy_cfg_addr_table[i];
		uint8 count = baseAddr & 0xFFu;
		baseAddr &= 0xFFFFFF00u;
		while (count--)
		{
			CY_SET_XTND_REG8((void CYFAR *)(baseAddr + cy_cfg_data_table[j].offset), cy_cfg_data_table[j].value);
			j++;
		}
	}
}
#endif

static void ClockSetup(void)
{
	reg32  timeout;
	reg32* timeout_p = &timeout;
	reg8   pllLock;

	CY_SET_XTND_REG24((void CYFAR *)(CYREG_CLKDIST_DCFG0_CFG0), 0x190017);
	CY_SET_XTND_REG24((void CYFAR *)(CYREG_CLKDIST_DCFG1_CFG0), 0x195DBF);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_CLKDIST_ACFG0_CFG0), (void CYCODE *)(BS_CYDEV_CLKDIST_ACFG0_CFG0_VAL), 8);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_SLOWCLK_ILO_CR0), 0x04);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_CR), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_IMO_TR1), (CY_GET_XTND_REG8(CYREG_FLSHID_CUST_TABLES_IMO_USB)));
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_FASTCLK_IMO_CR), 0x52);
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_P), 0x0710);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_CR), 0x00);
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_CFG0), 0x1051);
	pllLock = 0;
	for (timeout = 304; *timeout_p && (pllLock != 0x03u); timeout--) { pllLock = 0x03u & ((pllLock << 1) | ((CY_GET_XTND_REG8(CYREG_FASTCLK_PLL_SR) & 0x01u) >> 0)); }
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x0103);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x07);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_BCFG0), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_BCFG2), 0x48);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_UCFG), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_LD), 0x02);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_DLY1), 0x04);

	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PM_ACT_CFG2), ((CY_GET_XTND_REG8(CYREG_PM_ACT_CFG2) | 0x03)));
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PM_ACT_CFG1), ((CY_GET_XTND_REG8(CYREG_PM_ACT_CFG1) | 0x03)));
}

/* Analog API Functions */
void AnalogSetDefault(void)
{
	CY_SET_XTND_REG8(CYREG_PRT0_AG, 0xA0);
	CY_SET_XTND_REG8(CYREG_PRT6_AMUX, 0x80);
	CY_SET_XTND_REG8(CYREG_SC0_SW0, 0x04);
	CY_SET_XTND_REG8(CYREG_SC0_SW4, 0x40);
	CY_SET_XTND_REG8(CYREG_SC0_SW8, 0x02);
	CY_SET_XTND_REG8(CYREG_SC2_SW0, 0x04);
	CY_SET_XTND_REG8(CYREG_SC2_SW4, 0x80);
	CY_SET_XTND_REG8(CYREG_SC2_SW8, 0x10);
	CY_SET_XTND_REG8(CYREG_DAC0_SW3, 0x01);
	CY_SET_XTND_REG8(CYREG_DAC2_SW0, 0x20);
	CY_SET_XTND_REG8(CYREG_DSM0_SW0, 0x10);
	CY_SET_XTND_REG8(CYREG_DSM0_SW4, 0x02);
	CY_SET_XTND_REG16(CYREG_ABUF0_MX, 0x0220);
	CY_SET_XTND_REG8(CYREG_PUMP_CR0, 0x44);
}

#define CY_AMUX_UNUSED CYREG_BOOST_SR

/* This function is called by the start-up code for the selected device. */
void cyfitter_cfg(void)
{
	uint8 CYDATA i;

#ifdef CYGlobalIntDisable
	CYGlobalIntDisable;
#endif

	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x40 : 0x41));
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PHUB_CH0_BASIC_CFG), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PHUB_CH1_BASIC_CFG), 0x00);

	CY_SET_XTND_REG8((void CYFAR *)(CYREG_ANAIF_CFG_MISC_CR0), 0x01);

	CY_SET_XTND_REG8(CYREG_MLOGIC_DBG_DBE, (CY_GET_XTND_REG8(CYREG_MLOGIC_DBG_DBE) | 0x01));
	for (i = 0; i < CFG_MEMSET_COUNT; i++)
	{
		const cfg_memset_t CYCODE * CYDATA ms = &cfg_memset_list[i];
		CYMEMZERO(ms->address, ms->size);
	}

	for (i = 0; i < CFG_MEMCPY_COUNT; i++)
	{
		const cfg_memcpy_t CYCODE * CYDATA mc = &cfg_memcpy_list[i];
		void * CYDATA dest = mc->dest;
		const void CYCODE * CYDATA src = mc->src;
		uint16 CYDATA size = mc->size;
		CYCONFIGCPYCODE(dest, src, size);
	}

	cfg_write_bytes32();

	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT0_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT1_BASE), 7);
	CYCONFIGCPYCODE8((void CYFAR *)(CYDEV_PRTDSI_PRT2_BASE), (void CYCODE *)(BS_IOPORT_2_VAL), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT3_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT4_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT5_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT6_BASE), 7);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT12_BASE), 6);
	CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT15_BASE), 7);
	CYMEMZERO((void CYFAR *)(CYREG_PHUB_CFGMEM4_CFG0), 4);
	CYMEMZERO((void CYFAR *)(CYREG_PHUB_CFGMEM7_CFG0), 4);
	/* BYTES WRITTEN: 70 */

	/* Enable digital routing */
	CY_SET_XTND_REG8(CYREG_BCTL0_BANK_CTL, CY_GET_XTND_REG8(CYREG_BCTL0_BANK_CTL) | 0x02u);
	CY_SET_XTND_REG8(CYREG_BCTL1_BANK_CTL, CY_GET_XTND_REG8(CYREG_BCTL1_BANK_CTL) | 0x02u);

	/* Enable UDB array */
	CY_SET_XTND_REG8(CYREG_PM_ACT_CFG0, CY_GET_XTND_REG8(CYREG_PM_ACT_CFG0) | 0x40u);
	CY_SET_XTND_REG8(CYREG_PM_AVAIL_CR2, CY_GET_XTND_REG8(CYREG_PM_AVAIL_CR2) | 0x10u);

	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT0_DM0), (void CYCODE *)(BS_IOPINS0_0_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT15_DM0), (void CYCODE *)(BS_IOPINS0_8_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT2_DR), (void CYCODE *)(BS_IOPINS0_2_VAL), 10);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT6_DM0), (void CYCODE *)(BS_IOPINS0_6_VAL), 8);
	/* BYTES WRITTEN: 34 */

	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x00 : 0x01));
	ClockSetup();
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0xC0 : 0xC1));

	AnalogSetDefault();

	/* Configure alternate active mode */
	CYCONFIGCPY((void CYFAR *)CYDEV_PM_STBY_BASE, (void CYFAR *)CYDEV_PM_ACT_BASE, 12);
	CY_SET_XTND_REG8(CYREG_PM_STBY_CFG0, CY_GET_XTND_REG8(CYREG_PM_STBY_CFG0) & ~0x02u);	/* Disable CPU */
}
